<template>
  <div class="main-input-area">
    <date-picker input-class="todayInput"
                 v-model="date" type="month"
                 :clearable="false"
                 :lang="lang"
                 format="MMMM YYYY"
                 value-type="YYYY-MM"
                 :editable="false"
                 :disabled-date="disabledDate"
    />
    <button class="todayButton"
            @click="setToday">
      Сбросить
    </button>
  </div>
</template>

<script>
import moment from 'moment';
import DatePicker from 'vue2-datepicker';
import 'vue2-datepicker/index.css';

export default {
  name: 'DateInput',

  components: { DatePicker },

  props: [
    'startingDate',
  ],

  data() {
    return {
      date: '',
      lang: {
        formatLocale: {
          months: ['Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь'],
          monthsShort: ['Январь', 'Февраль', 'Март', 'Апрель', 'Май', 'Июнь', 'Июль', 'Август', 'Сентябрь', 'Октябрь', 'Ноябрь', 'Декабрь'],
        },
      },
    };
  },

  watch: {
    date(date) {
      this.$emit('changeDate', date);
    },
    startingDate() {
      this.setToday();
    },
  },

  created() {
    this.setToday();
  },

  methods: {
    disabledDate(date) {
      return moment(date).format('YYYY-MM') < moment(this.startingDate).add(1, 'month').format('YYYY-MM');
    },

    setToday() {
      this.date = moment().format('YYYY-MM');
    },
  },
};
</script>
